import os
import glob
import datetime
import time
import sqlite3
from datetime import datetime

os.system('modprobe w1-gpio')
os.system('modprobe w1-therm')

base_dir = '/sys/bus/w1/devices/'
device_folder = glob.glob(base_dir + '28*')[0]
device_file = device_folder + '/w1_slave'

def read_temp_raw():
    f = open(device_file, 'r')
    lines = f.readlines()
    f.close()
    return lines

def read_temp():
    lines = read_temp_raw()
    while lines[0].strip()[-3:] != 'YES':
        time.sleep(0.2)
        lines = read_temp_raw()
    equals_pos = lines[1].find('t=')
    if equals_pos != -1:
        temp_string = lines[1][equals_pos+2:]
        temp_c = float(temp_string) / 1000.0
        temp_f = temp_c * 9.0 / 5.0 + 32.0
        return temp_c

dbname='/home/pi/TempMonitor/sensorsData.db'
sampleFreq = 1200

def datetime_from_utc_to_local(utc_datetime):
    now_timestamp = time.time()
    offset = datetime.fromtimestamp(now_timestamp) - datetime.utcfromtimestamp(now_timestamp)
    return utc_datetime + offset


def logData (temp):
    conn=sqlite3.connect(dbname)
    curs=conn.cursor()

    curs.execute("INSERT INTO DHT_data values((datetime('now', 'localtime')), (?))", (temp,))
    conn.commit()
    conn.close()

# main function
def main():
	while True:
		temp = round(read_temp(),0)
		logData(temp)
		print('The temperature is' ,temp, 'c')

		if temp < 15:
			emailcontent = "On {}, the temperature inside the house was recorded at {}c by the pi.  Requires immediate investigation.".format(datetime.now(), temp)
			emailcommand = 'sudo echo "{}" | mail -s "WARNING: HOUSE TEMPERATURE TOO LOW" youremail@domain.com'.format(emailcontent)
			os.system(emailcommand)


		os.system('sqlite3 /home/pi/TempMonitor/sensorsData.db "SELECT * FROM DHT_DATA ORDER BY timestamp DESC LIMIT 1;" > /home/pi/TempMonitor/LastTemp.txt')
		time.sleep(3)
		os.system('ncftpput -u username -p password ftp.domain.com / /home/pi/TempMonitor/LastTemp.txt')

		time.sleep(sampleFreq)

main()
